package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function7;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.apotheosis.adventure.loot.AffixLootEntry;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityClamp;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.json.ItemAdapter;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;
import javax.annotation.Nullable;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;

public final class AffixLootEntry implements CodecProvider<AffixLootEntry>, WeightedDynamicRegistry.ILuckyWeighted, WeightedDynamicRegistry.IDimensional, RarityClamp, GameStagesCompat.IStaged {
  public static final Codec<AffixLootEntry> CODEC;
  
  protected final int weight;
  
  protected final float quality;
  
  protected final ItemStack stack;
  
  protected final Set<ResourceLocation> dimensions;
  
  protected final DynamicHolder<LootRarity> minRarity;
  
  protected final DynamicHolder<LootRarity> maxRarity;
  
  @Nullable
  protected final Set<String> stages;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)Codec.intRange(0, 2147483647).fieldOf("weight").forGetter(WeightedDynamicRegistry.ILuckyWeighted::getWeight), (App)PlaceboCodecs.nullableField(Codec.floatRange(0.0F, Float.MAX_VALUE), "quality", Float.valueOf(0.0F)).forGetter(WeightedDynamicRegistry.ILuckyWeighted::getQuality), (App)ItemAdapter.CODEC.fieldOf("stack").forGetter(()), (App)PlaceboCodecs.setOf(ResourceLocation.f_135803_).fieldOf("dimensions").forGetter(()), (App)RarityRegistry.INSTANCE.holderCodec().fieldOf("min_rarity").forGetter(()), (App)RarityRegistry.INSTANCE.holderCodec().fieldOf("max_rarity").forGetter(()), (App)PlaceboCodecs.nullableField(PlaceboCodecs.setOf((Codec)Codec.STRING), "stages").forGetter(())).apply((Applicative)inst, AffixLootEntry::new));
  }
  
  public AffixLootEntry(int weight, float quality, ItemStack stack, Set<ResourceLocation> dimensions, DynamicHolder<LootRarity> min, DynamicHolder<LootRarity> max, Optional<Set<String>> stages) {
    this.weight = weight;
    this.quality = quality;
    this.stack = Objects.<ItemStack>requireNonNull(stack);
    this.dimensions = dimensions;
    this.minRarity = min;
    this.maxRarity = max;
    this.stages = stages.orElse(null);
  }
  
  public AffixLootEntry(int weight, float quality, ItemStack stack, Set<ResourceLocation> dimensions, DynamicHolder<LootRarity> min, DynamicHolder<LootRarity> max) {
    this(weight, quality, stack, dimensions, min, max, Optional.empty());
  }
  
  public int getWeight() {
    return this.weight;
  }
  
  public float getQuality() {
    return this.quality;
  }
  
  public ItemStack getStack() {
    return this.stack.m_41777_();
  }
  
  public Set<ResourceLocation> getDimensions() {
    return this.dimensions;
  }
  
  public LootRarity getMinRarity() {
    return (LootRarity)this.minRarity.get();
  }
  
  public LootRarity getMaxRarity() {
    return (LootRarity)this.maxRarity.get();
  }
  
  public LootCategory getType() {
    return LootCategory.forItem(this.stack);
  }
  
  public Set<String> getStages() {
    return this.stages;
  }
  
  public Codec<? extends AffixLootEntry> getCodec() {
    return CODEC;
  }
}
